<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










Class Captcha
{
	private $img;
	private $height;
	private $width;
	private $type;
	private $cr;//coleur rouge
	private $cv;//coleur vert
	private $cb;//coleur bleu
	private $c;//coleur (melange des trois
	private $code;
	function __construct()
	{
		global $configs;
		switch(strtolower($this->type))
		{
			case 'gif' :
			case 'png' :
			case 'jpeg' :
				$this->type = $type;
				break;
			case 'jpg' :
				$this->type = 'jpeg';
				break;
			default :
				$this->type = 'png';
		}
	}
	function __destruct()
	{
		
	}
	public function create($w,$h)
	{
		global $s,$configs;
		$this->header();
		$this->img = imagecreatetruecolor($w,$h);
		//rectangle
		$this->createFilledRectangle($configs['config_captcha_border_color'],0,0,$w,$h);
		//rectangle
		$this->createFilledRectangle($configs['config_captcha_bg_color'],$configs['config_captcha_border_size'],$configs['config_captcha_border_size'],($w-1)-$configs['config_captcha_border_size'],($h-1)-$configs['config_captcha_border_size']);
		//chars
		$this->createCode($w,$h);
		//bruits
		$this->createNoise($w,$h);
		$func = 'image'.$this->type;
		$func($this->img);
		imagedestroy($this->img);
	}
	private function createNoise($w,$h)
	{
		global $configs;
		$border = $configs['config_captcha_border_size'];
		switch($configs['config_captcha_noise_level'])
		{
			case 'level1' :
				for($i=0;$i<1;$i++)
					$this->createFilledEllipse($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$h-$border),rand(0,6),rand(0,6));
				for($i=0;$i<10;$i++)
					$this->createPixel($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$h-$border));
				for($i=0;$i<2;$i++)
					$this->createLine($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$w-$border),rand(0+$border,$h-$border),rand(0+$border,$h-$border));
				break;
			case 'level2' :
				for($i=0;$i<3;$i++)
					$this->createFilledEllipse($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$h-$border),rand(0,6),rand(0,6));
				for($i=0;$i<25;$i++)
					$this->createPixel($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$h-$border));
				for($i=0;$i<4;$i++)
					$this->createLine($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$w-$border),rand(0+$border,$h-$border),rand(0+$border,$h-$border));
				break;
			case 'level3' :
				for($i=0;$i<5;$i++)
					$this->createFilledEllipse($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$h-$border),rand(0,6),rand(0,6));
				for($i=0;$i<35;$i++)
					$this->createPixel($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$h-$border));
				for($i=0;$i<6;$i++)
					$this->createLine($this->randColor(),rand(0+$border,$w-$border),rand(0+$border,$w-$border),rand(0+$border,$h-$border),rand(0+$border,$h-$border));
				break;
			default :
		}
	}
	private function createFilledEllipse($color,$cx,$cy,$w,$h)
	{
		$this->setColor($color);
		imagefilledellipse($this->img,$cx,$cy,$w,$h,$this->c);
	}
	private function createPixel($color,$x,$y)
	{
		$this->setColor($color);
		imagesetpixel($this->img,$x,$y,$this->c);
	}
	private function createLine($color,$x,$y,$xd,$yd)
	{
		$this->setColor($color);
		imageline($this->img,$x,$y,$xd,$yd,$this->c);
	}
	private function createFilledRectangle($color,$x,$y,$xd,$yd)
	{
		$this->setColor($color);
		imagefilledrectangle($this->img,$x,$y,$xd,$yd,$this->c);
	}
	private function createRectangle($color,$x,$y,$xd,$yd)
	{
		$this->setColor($color);
		imagerectangle($this->img,$x,$y,$xd,$yd,$this->c);
	}
	private function createCode($w,$h)
	{
		global $s,$configs;
		$this->code = $s->getVar('captcha_code');
		$this->setColor($configs['config_captcha_font_color']);//couleur par default
		for($i=0;$i<$configs['config_captcha_length'];$i++)
		{
			if($configs['config_captcha_font_color_random'] == 'yes')
				$this->setColor($this->randColor());//couleur alaetoire
			$x = round((($w-$configs['config_captcha_border_size'])/$configs['config_captcha_length'])*$i)+1+$configs['config_captcha_border_size'];
			$y = rand($configs['config_captcha_border_size'],($h-$configs['config_captcha_border_size'])-15);
			imagechar($this->img,$configs['config_captcha_font_size'],$x,$y,$this->code[$i],$this->c);
		}
	}
	private function setColor($hex)
	{
		$this->cr = hexdec($hex[0].$hex[1]);
		$this->cv = hexdec($hex[2].$hex[3]);
		$this->cb = hexdec($hex[4].$hex[5]);
		$this->c = imagecolorallocate($this->img,$this->cr,$this->cv,$this->cb);
	}
	private function randColor()
	{
		$chars = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, "A", "B", "C", "D", "E", "F");
		$color="";
		for($i=0;$i<6;$i++)
			$color .= $chars[array_rand($chars)];
		return $color;
	}

	public function createError($w,$h)
	{
		global $s,$configs;
		$this->header();
		$this->img = imagecreatetruecolor($w,$h);
		imagecolordeallocate($this->img,$this->c);
		//rectangle
		$this->createFilledRectangle($configs['config_captcha_border_color'],0,0,$w,$h);
		//rectangle
		$this->createFilledRectangle($configs['config_captcha_bg_color'],$configs['config_captcha_border_size'],$configs['config_captcha_border_size'],($w-1)-$configs['config_captcha_border_size'],($h-1)-$configs['config_captcha_border_size']);
		//chars
		$this->setColor($configs['config_captcha_font_color']);//couleur par default
		imagestring($this->img,5,1,1,translate("Error"),$this->c);
		imagepng($this->img);
		imagedestroy($this->img);
	}
	private function header()
	{
		header('Expires: Mon, 01 Jan 2000 00:00:00 GMT');
		header('Last-Modified: ' . gmdate("D, d M Y H:i:s") . ' GMT');
		header('Cache-Control: no-store, no-cache, must-revalidate');
		header('Cache-Control: post-check=0, pre-check=0', false);
		header('Pragma: no-cache');
		header('Content-Type: image/' . $this->type);
	}
}
?>